* split travelmate.s in a new central travelmate function library (usr/lib/travelmate-functions.sh) plus
a smal service script (/usr/bin/travelmate-service.sh)
* the vpn-, mail- and login scripts are now using the central function library
* rework the ntp hotplug script
* harden the config parsing
* support the curl interface option to specify which network pathway is used for outgoing requests
* the travelmate status now includes the backend- and frontend version information
* LuCI: use a special travelmate interface, e.g. trm_wwan or use an existing wwan interface
* LuCI: no longer call the logread binary, use rpc / the ubus log object instead
* LuCI: various code cleanups
* LuCI: various small usability improvements
* readme update
Signed-off-by: Dirk Brenken <redacted>
include $(TOPDIR)/rules.mk
PKG_NAME:=travelmate
-PKG_VERSION:=2.2.1
-PKG_RELEASE:=6
+PKG_VERSION:=2.3.0
+PKG_RELEASE:=1
PKG_LICENSE:=GPL-3.0-or-later
PKG_MAINTAINER:=Dirk Brenken <dev@brenken.org>
define Package/travelmate/install
$(INSTALL_DIR) $(1)/usr/bin
- $(INSTALL_BIN) ./files/travelmate.sh $(1)/usr/bin
+ $(INSTALL_BIN) ./files/travelmate-service.sh $(1)/usr/bin
$(INSTALL_DIR) $(1)/etc/init.d
$(INSTALL_BIN) ./files/travelmate.init $(1)/etc/init.d/travelmate
+ $(INSTALL_DIR) $(1)/usr/lib
+ $(INSTALL_CONF) ./files/travelmate-functions.sh $(1)/usr/lib
+
$(INSTALL_DIR) $(1)/etc/hotplug.d/ntp
- $(INSTALL_BIN) ./files/travelmate_ntp.hotplug $(1)/etc/hotplug.d/ntp/25-travelmate_ntp
+ $(INSTALL_BIN) ./files/25-travelmate.hotplug $(1)/etc/hotplug.d/ntp/25-travelmate
$(INSTALL_DIR) $(1)/etc/config
$(INSTALL_CONF) ./files/travelmate.conf $(1)/etc/config/travelmate
$(INSTALL_DIR) $(1)/etc/travelmate
+ $(INSTALL_CONF) ./files/mail.template $(1)/etc/travelmate
$(INSTALL_BIN) ./files/travelmate.vpn $(1)/etc/travelmate
- $(INSTALL_BIN) ./files/travelmate.mail $(1)/etc/travelmate
$(INSTALL_BIN) ./files/*.login $(1)/etc/travelmate
endef
--- /dev/null
+#!/bin/sh
+# ntp hotplug script for travelmate
+# Copyright (c) 2020-2025 Dirk Brenken (dev@brenken.org)
+# This is free software, licensed under the GNU General Public License v3.
+
+# set (s)hellcheck exceptions
+# shellcheck disable=all
+
+trm_init="/etc/init.d/travelmate"
+trm_funlib="/usr/lib/travelmate-functions.sh"
+trm_ntplock="/var/lock/travelmate.ntp.lock"
+
+if mkdir "${trm_ntplock}" 2>/dev/null; then
+ if [ "${ACTION}" = "stratum" ] && "${trm_init}" enabled; then
+ . "${trm_funlib}"
+ f_log "info" "get ntp time sync"
+ fi
+fi
to make sure that the AP is always accessible
## Prerequisites
-* [OpenWrt](https://openwrt.org), tested/compatible with current stable 23.x and latest OpenWrt snapshot
+* [OpenWrt](https://openwrt.org), tested/compatible with current stable and latest OpenWrt snapshot
* The `luci-app-travelmate` ensures these packages are present:
* 'dnsmasq' as dns backend
* 'iw' for wlan scanning
## Captive Portal auto-logins
For automated captive portal logins you can reference an external shell script per uplink. All login scripts should be executable and located in '/etc/travelmate' with the extension '.login'. The package ships multiple ready to run auto-login scripts:
- * 'wifionice.login' for ICE hotspots (DE)
- * 'db-bahn.login' for german DB railway hotspots via portal login API (still WIP, only tested at Hannover central station)
- * 'chs-hotel.login' for german chs hotels
- * 'h-hotels.login' for Telekom hotspots in h+hotels (DE)
- * 'julianahoeve.login' for Julianahoeve beach resort (NL)
+ * 'wifibahn.login' for german DB railway hotspots
* 'telekom.login' for telekom hotspots (DE)
* 'vodafone.login' for vodafone hotspots (DE)
* 'generic-user-pass.login' a template to demonstrate the optional parameter handling in login scripts
<pre><code>
root@2go:~# /etc/init.d/travelmate status
::: travelmate runtime information
- + travelmate_status : connected (net ok/96)
- + travelmate_version : 2.2.1-r1
+ + travelmate_status : connected, net ok/100
+ + frontend_ver : 2.3.0-r1
+ + backend_ver : 2.3.0-r1
+ station_id : radio0/GlutenfreiVerbunden/-
- + station_mac : 1E:24:62:C3:2E:4B
- + station_interfaces : trm_wwan, -
- + station_subnet : 10.168.20.0 (lan: 10.168.1.0)
- + run_flags : scan: passive, captive: ✔, proactive: ✔, netcheck: ✘, autoadd: ✘, randomize: ✔
- + ext_hooks : ntp: â\9c\94, vpn: â\9c\98, mail: â\9c\98
- + last_run : 2025.10.18-21:03:41
- + system : Cudy TR3000 v1, mediatek/filogic, OpenWrt SNAPSHOT r31445-2a44808374
+ + station_mac : 42:40:45:EC:B3:D1
+ + station_interfaces : wwan, -
+ + station_subnet : 10.168.20.0 (lan: 10.200.1.0)
+ + run_flags : scan: active, captive: ✔, proactive: ✔, netcheck: ✘, autoadd: ✘, randomize: ✔
+ + ext_hooks : ntp: â\9c\94, vpn: â\9c\98, mail: â\9c\94
+ + last_run : 2025.12.11-09:08:24
+ + system : Cudy TR3000 v1, mediatek/filogic, OpenWrt SNAPSHOT (r32287-1c7ec8ab19)
</code></pre>
To debug travelmate runtime problems, please always enable the 'trm\_debug' flag, restart Travelmate and check the system log afterwards (_logread -e "trm-"_)
+++ /dev/null
-#!/bin/sh
-# captive portal auto-login script for chs hotels (DE)
-# Copyright (c) 2020-2022 Dirk Brenken (dev@brenken.org)
-# This is free software, licensed under the GNU General Public License v3.
-
-# set (s)hellcheck exceptions
-# shellcheck disable=1091,2181,3040
-
-. "/lib/functions.sh"
-
-export LC_ALL=C
-export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
-trm_domain="hotspot.internet-for-guests.com"
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl)"
-
-# get security tokens
-#
-"${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://www.example.com" --silent --connect-timeout $((trm_maxwait / 6)) --cookie-jar "/tmp/${trm_domain}.cookie" --output /dev/null "https://${trm_domain}/logon/cgi/index.cgi"
-lg_id="$(awk '/LGNSID/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
-ta_id="$(awk '/ta_id/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
-cl_id="$(awk '/cl_id/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
-rm -f "/tmp/${trm_domain}.cookie"
-{ [ -z "${lg_id}" ] || [ -z "${ta_id}" ] || [ -z "${cl_id}" ]; } && exit 1
-
-# final login request
-#
-"${trm_fetch}" --user-agent "${trm_useragent}" --referer "https://${trm_domain}/logon/cgi/index.cgi" --silent --connect-timeout $((trm_maxwait / 6)) --header "Cookie: LGNSID=${lg_id}; lang=en_US; use_mobile_interface=0; ta_id=${ta_id}; cl_id=${cl_id}" --data "accept_termsofuse=&freeperperiod=1&device_infos=1125:2048:1152:2048" --output /dev/null "https://${trm_domain}/logon/cgi/index.cgi"
-[ "${?}" = "0" ] && exit 0 || exit 255
#!/bin/sh
# captive portal auto-login script template with credentials as parameters
-# Copyright (c) 2020-2022 Dirk Brenken (dev@brenken.org)
+# Copyright (c) 2020-2025 Dirk Brenken (dev@brenken.org)
# This is free software, licensed under the GNU General Public License v3.
# set (s)hellcheck exceptions
-# shellcheck disable=1091,2039,3040
-
-. "/lib/functions.sh"
+# shellcheck disable=all
export LC_ALL=C
export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
+trm_funlib="/usr/lib/travelmate-functions.sh"
+if [ -z "${trm_bver}" ]; then
+ . "${trm_funlib}"
+ f_conf
+fi
+
user="${1}"
password="${2}"
-success="Thank you!"
trm_domain="example.com"
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl)"
+if ! "${trm_lookupcmd}" "${trm_domain}" >/dev/null 2>&1; then
+ exit 1
+fi
# login with credentials
#
-raw_html="$("${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://www.example.com" --connect-timeout $((trm_maxwait / 6)) --silent --show-error --header "Content-Type:application/x-www-form-urlencoded" --data "username=${user}&password=${password}" "http://${trm_domain}")"
-[ -z "${raw_html##*${success}*}" ] && exit 0 || exit 255
+raw_html="$("${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" --header "Content-Type:application/x-www-form-urlencoded" --data "username=${user}&password=${password}" "http://${trm_domain}")"
+[ -z "${raw_html}" ] && exit 0 || exit 255
+
+++ /dev/null
-#!/bin/sh
-# captive portal auto-login script for hotspots in h+hotels (DE)
-# Copyright (c) 2020-2024 Dirk Brenken (dev@brenken.org)
-# This is free software, licensed under the GNU General Public License v3.
-
-# set (s)hellcheck exceptions
-# shellcheck disable=all
-
-. "/lib/functions.sh"
-
-export LC_ALL=C
-export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
-trm_domain="hotspot.netcontrol365.com"
-if ! nslookup "${trm_domain}" >/dev/null 2>&1; then
- trm_domain="hotspot.t-mobile.net"
- if ! nslookup "${trm_domain}" >/dev/null 2>&1; then
- exit 1
- fi
-fi
-
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl)"
-
-if [ "${trm_domain}" = "hotspot.netcontrol365.com" ]; then
- raw_html="$("${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://www.example.com" --connect-timeout $((trm_maxwait / 6)) --silent --show-error --header "Content-Type:application/x-www-form-urlencoded" --data "dst=&popup=false&username=hhotel&accept=on&login=" --output /dev/null "http://${trm_domain}/login")"
- [ -z "${raw_html}" ] && exit 0 || exit 255
-else
- "${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://www.example.com" --silent --connect-timeout $((trm_maxwait / 6)) --cookie-jar "/tmp/${trm_domain}.cookie" --output /dev/null "https://${trm_domain}/wlan/rest/freeLogin"
- ses_id="$(awk '/JSESSIONID/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
- sec_id="$(awk '/DT_H/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
- dev_id="$(sha256sum /etc/config/wireless 2>/dev/null | awk '{printf "%s",substr($1,1,13)}' 2>/dev/null)"
- rm -f "/tmp/${trm_domain}.cookie"
- { [ -z "${ses_id}" ] || [ -z "${sec_id}" ] || [ -z "${dev_id}" ]; } && exit 2
-
- "${trm_fetch}" --user-agent "${trm_useragent}" --referer "https://${trm_domain}/TD/hotspot/H_Hotels/en_GB/index.html" --silent --connect-timeout $((trm_maxwait / 6)) --header "Cookie: JSESSIONID=${ses_id}; DT_DEV_ID=${dev_id}; DT_H=${sec_id}" --data "rememberMe=true" --output /dev/null "https://${trm_domain}/wlan/rest/freeLogin"
- [ "${?}" = "0" ] && exit 0 || exit 255
-fi
+++ /dev/null
-#!/bin/sh
-# captive portal auto-login script for H-Reward Hotelss
-# This is free software, licensed under the GNU General Public License v3.
-
-# set (s)hellcheck exceptions
-# shellcheck disable=1091,2039,3040
-#
-#
-# Username and password can be passed to the script, to get fast wifi
-# If not provided, the option with the slower wifi will be selected
-
-
-. "/lib/functions.sh"
-
-
-export LC_ALL=C
-export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
-
-# From https://stackoverflow.com/a/17336953/819367 converted to sh
-rawurlencode() {
- string="$1"
- strlen=${#string}
- encoded=""
- pos=0
- c=""
- o=""
-
- while [ $pos -lt $strlen ]; do
- c=$(expr substr "$string" $((pos + 1)) 1)
- case "$c" in
- [-_.~a-zA-Z0-9] ) o="${c}" ;;
- * ) o=$(printf '%%%02x' "'$c")
- esac
- encoded="${encoded}${o}"
- pos=$((pos + 1))
- done
-
- echo "${encoded}"
-}
-
-user=$(rawurlencode "${1}")
-password=$(rawurlencode "${2}")
-
-successUrl="https://hrewards.com/en"
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-
-set -e
-
-
-session_key="$(curl -sL --user-agent "${trm_useragent}" \
- --connect-timeout $((trm_maxwait / 6)) \
- "http://nossl.com/?cmd=redirect&arubalp=12345" \
- | awk -F 'name="session_key" value="' 'NF>1{split($2,a,"\""); print a[1]; exit}')"
-
-if [ -n "$user" ] && [ -n "$password" ]; then
- response="$(curl -sL --user-agent "${trm_useragent}" \
- --connect-timeout $((trm_maxwait / 6)) \
- -w %{url_effective} \
- -o /dev/null \
- --header "Content-Type:application/x-www-form-urlencoded" \
- --data "session_key=${session_key}&accept_terms=1&email=${user}&password=${password}&password_reset_form_email=&password_update_form_password=&password_update_form_password_repeat=&room_number=&last_name=&voucher=" \
- "https://cp.deutschehospitality.com/aruba/login?lang=en")"
-else
- response="$(curl -sL --user-agent "${trm_useragent}" \
- --connect-timeout $((trm_maxwait / 6)) \
- -w %{url_effective} \
- -o /dev/null \
- --header "Content-Type:application/x-www-form-urlencoded" \
- --data "session_key=${session_key}&email=&password=&accept_terms=1&password_reset_form_email=&password_update_form_password=&password_update_form_password_repeat=&room_number=&last_name=&voucher=" \
- "https://cp.deutschehospitality.com/aruba/skip-registration?lang=en")"
-fi
-
-if [ "$response" != "$successUrl" ]; then
- exit 255
-fi
+++ /dev/null
-#!/bin/sh
-# captive portal auto-login script for Julianahoeve beach resort (NL)
-# Copyright (c) 2021-2022 Dirk Brenken (dev@brenken.org)
-# This is free software, licensed under the GNU General Public License v3.
-
-# set (s)hellcheck exceptions
-# shellcheck disable=1091,2039,2181,3040
-
-. "/lib/functions.sh"
-
-export LC_ALL=C
-export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
-trm_domain="n23.network-auth.com"
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_captiveurl="$(uci_get travelmate global trm_captiveurl "http://detectportal.firefox.com")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl)"
-
-# get redirect url
-#
-redirect_url="$(${trm_fetch} --user-agent "${trm_useragent}" --referer "http://www.example.com" --connect-timeout $((trm_maxwait / 6)) --write-out "%{redirect_url}" --silent --show-error --output /dev/null "${trm_captiveurl}")"
-[ -z "${redirect_url}" ] && exit 1
-
-# get session cookie
-#
-"${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://${trm_domain}" --silent --connect-timeout $((trm_maxwait / 6)) --cookie-jar "/tmp/${trm_domain}.cookie" --output /dev/null "${redirect_url}"
-session_id="$(awk '/p_splash_session/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
-rm -f "/tmp/${trm_domain}.cookie"
-[ -z "${session_id}" ] && exit 2
-
-# final login request
-#
-"${trm_fetch}" --user-agent "${trm_useragent}" --referer "${redirect_url}" --silent --connect-timeout $((trm_maxwait / 6)) --header "Cookie: p_splash_session=${session_id};" --output /dev/null "https://${trm_domain}/Camping-Julianah/hi/IHYW9cx/grant"
-[ "${?}" = "0" ] && exit 0 || exit 255
--- /dev/null
+# travelmate mail template/include - a wlan connection manager for travel router
+# Copyright (c) 2016-2025 Dirk Brenken (dev@brenken.org)
+# This is free software, licensed under the GNU General Public License v3.
+
+# info preparation
+#
+local travelmate_status station_info system_info mail_text
+
+travelmate_status="$(/etc/init.d/travelmate status 2>/dev/null)"
+system_info="$(strings /etc/banner 2>/dev/null
+ "${trm_ubuscmd}" call system board |
+ "${trm_awkcmd}" 'BEGIN{FS="[{}\"]"}{if($2=="kernel"||$2=="hostname"||$2=="system"||$2=="model"||$2=="description")printf " + %-12s: %s\n",$2,$4}')"
+station_info="$("${trm_jsoncmd}" -i "${trm_rtfile}" -q -l1 -e '@.data.station_id')"
+
+# content header
+#
+mail_text="$(printf "%s\n" "<html><body><pre style='font-family:monospace;padding:20;background-color:#f3eee5;white-space:pre-wrap;overflow-x:auto;' >")"
+
+# content body
+#
+mail_text="$(printf "%s\n" "${mail_text}\n<strong>++\n++ System Information ++\n++</strong>\n${system_info:-"-"}")"
+mail_text="$(printf "%s\n" "${mail_text}\n\n<strong>++\n++ Travelmate Status ++\n++</strong>\n${travelmate_status:-"-"}")"
+[ -n "${station_info}" ] && mail_text="$(printf "%s\n" "${mail_text}\n\n<strong>++\n++ Connection Status ++\n++</strong>\ntravelmate connection to ${station_info}")"
+
+# content footer
+#
+mail_text="$(printf "%s\n" "${mail_text}</pre></body></html>")"
# set (s)hellcheck exceptions
# shellcheck disable=all
-. "/lib/functions.sh"
-
# url encoding function
#
urlencode()
export LC_ALL=C
export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
+trm_funlib="/usr/lib/travelmate-functions.sh"
+if [ -z "${trm_bver}" ]; then
+ . "${trm_funlib}"
+ f_conf
+fi
+
username="$(urlencode "${1}")"
password="$(urlencode "${2}")"
trm_domain="hotspot.t-mobile.net"
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_captiveurl="$(uci_get travelmate global trm_captiveurl "http://detectportal.firefox.com")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl)"
+if ! "${trm_lookupcmd}" "${trm_domain}" >/dev/null 2>&1; then
+ exit 1
+fi
# get redirect url
#
-raw_html="$(${trm_fetch} --user-agent "${trm_useragent}" --referer "http://www.example.com" --connect-timeout $((trm_maxwait / 6)) --location --silent --show-error "${trm_captiveurl}")"
-redirect_url="$(printf "%s" "${raw_html}" | awk 'match(tolower($0),/<loginurl>.*<\/loginurl>/){printf "%s",substr($0,RSTART+10,RLENGTH-21)}' 2>/dev/null | awk '{gsub("&","\\&");printf "%s",$0}' 2>/dev/null)"
+raw_html="$("${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" "${trm_captiveurl}")"
+redirect_url="$(printf "%s" "${raw_html}" | "${trm_awkcmd}" 'match(tolower($0),/<loginurl>.*<\/loginurl>/){printf "%s",substr($0,RSTART+10,RLENGTH-21)}' 2>/dev/null | "${trm_awkcmd}" '{gsub("&","\\&");printf "%s",$0}' 2>/dev/null)"
[ -z "${redirect_url}" ] && exit 1
# final login request
#
-raw_html="$("${trm_fetch}" --user-agent "${trm_useragent}" --referer "https://${trm_domain}/wlan/rest/freeLogin" --connect-timeout $((trm_maxwait / 6)) --header "content-type: application/x-www-form-urlencoded" --location --silent --show-error --data "UserName=${username}&Password=${password}&FNAME=0&button=Login&OriginatingServer=http%3A%2F%2F${trm_captiveurl}" "${redirect_url}")"
-login_url="$(printf "%s" "${raw_html}" | awk 'match(tolower($0),/<logoffurl>.*<\/logoffurl>/){printf "%s",substr($0,RSTART+11,RLENGTH-23)}' 2>/dev/null)"
+raw_html="$("${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" --referer "https://${trm_domain}/wlan/rest/freeLogin" --header "content-type: application/x-www-form-urlencoded" --data "UserName=${username}&Password=${password}&FNAME=0&button=Login&OriginatingServer=http%3A%2F%2F${trm_captiveurl}" "${redirect_url}")"
+login_url="$(printf "%s" "${raw_html}" | "${trm_awkcmd}" 'match(tolower($0),/<logoffurl>.*<\/logoffurl>/){printf "%s",substr($0,RSTART+11,RLENGTH-23)}' 2>/dev/null)"
[ -n "${login_url}" ] && exit 0 || exit 255
+++ /dev/null
-#!/bin/sh
-# captive portal auto-login script for TP-Link Omada (authType=0 only)
-# Copyright (c) 2022 Sebastian Muszynski <basti@linkt.de>
-# This is free software, licensed under the GNU General Public License v3
-
-# set (s)hellcheck exceptions
-# shellcheck disable=1091,2181,3037,3043,3057
-
-. "/lib/functions.sh"
-. "/usr/share/libubox/jshn.sh"
-
-urlencode()
-{
- local chr str="${1}" len="${#1}" pos=0
-
- while [ "${pos}" -lt "${len}" ]; do
- chr="${str:pos:1}"
- case "${chr}" in
- [a-zA-Z0-9.~_-])
- printf "%s" "${chr}"
- ;;
- " ")
- printf "%%20"
- ;;
- *)
- printf "%%%02X" "'${chr}"
- ;;
- esac
- pos=$((pos + 1))
- done
-}
-
-urldecode()
-{
- echo -e "$(sed 's/+/ /g;s/%\(..\)/\\x\1/g;')"
-}
-
-request_parameter()
-{
- grep -oE "$1=[^&]+" | cut -d= -f2
-}
-
-export LC_ALL=C
-export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
-trm_captiveurl="$(uci_get travelmate global trm_captiveurl "http://detectportal.firefox.com")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl) --connect-timeout $((trm_maxwait / 6)) --silent"
-
-raw_html="$(${trm_fetch} --show-error "${trm_captiveurl}")"
-
-if [ $? -ne 0 ];
-then
- echo "The captive portal didn't respond"
- exit 1
-fi
-
-if [ "$raw_html" = "success" ];
-then
- echo "Internet access already available"
- exit 0
-fi
-
-redirect_url=$(echo "$raw_html" | grep -oE 'location.href="[^\"]+"' | cut -d\" -f2)
-
-portal_baseurl=$(echo "$redirect_url" | cut -d/ -f1-4)
-client_mac=$(echo "$redirect_url" | request_parameter cid)
-ap_mac=$(echo "$redirect_url" | request_parameter ap)
-ssid=$(echo "$redirect_url" | request_parameter ssid | urldecode)
-radio_id=$(echo "$redirect_url" | request_parameter rid)
-url=$(echo "$redirect_url" | request_parameter u | urldecode)
-
-${trm_fetch} "${portal_baseurl}/pubKey" | jsonfilter -e '@.result.key' > /tmp/trm-omada-pub.key
-if [ $? -ne 0 ];
-then
- exit 2
-fi
-
-json_init
-json_add_string "clientMac" "$client_mac"
-json_add_string "apMac" "$ap_mac"
-json_add_string "ssidName" "$ssid"
-json_add_int "radioId" "$radio_id"
-json_add_string "originUrl" "$url"
-json_close_object
-incomplete_auth_request="$(json_dump)"
-
-auth_type=$(${trm_fetch} "${portal_baseurl}/getPortalPageSetting" \
- -H 'Accept: application/json' \
- -H 'Content-Type: application/json' \
- -H 'X-Requested-With: XMLHttpRequest' \
- --data-raw "$incomplete_auth_request" | jsonfilter -e '@.result.authType')
-
-if [ "$auth_type" -ne 0 ];
-then
- echo "Unsupported auth type: $auth_type"
- exit 3
-fi
-
-aes_key=$(tr -dc 'a-zA-Z0-9' < /dev/urandom | head -c 16)
-aes_key_hex=$(printf "%s" "$aes_key" | hexdump -e '16/1 "%02x"')
-aes_vi=$(tr -dc 'a-zA-Z0-9' < /dev/urandom | head -c 16)
-aes_vi_hex=$(printf "%s" "$aes_vi" | hexdump -e '16/1 "%02x"')
-
-rsa_encrypted_aes_secrets=$(printf "%s" "${aes_key}${aes_vi}" | openssl rsautl -encrypt -pubin -inkey /tmp/trm-omada-pub.key | base64 -w 0)
-rsa_encrypted_aes_secrets_urlencoded=$(urlencode "$rsa_encrypted_aes_secrets")
-
-json_load "$incomplete_auth_request"
-json_add_int "authType" "$auth_type"
-json_close_object
-auth_request="$(json_dump)"
-
-aes_encrypted_auth_request="$(echo "$auth_request" | openssl enc -aes-128-cbc -K "$aes_key_hex" -iv "$aes_vi_hex" -a -A)"
-
-auth_response=$(${trm_fetch} "${portal_baseurl}/auth?key=$rsa_encrypted_aes_secrets_urlencoded" \
- -H 'Content-Type: text/plain' \
- -H 'X-Requested-With: XMLHttpRequest' \
- --data-raw "$aes_encrypted_auth_request" \
- --insecure)
-
-if echo "$auth_response" | grep -q '{"errorCode":0}';
-then
- exit 0
-fi
-
-exit 255
-#!/bin/sh
-# travelmate, a wlan connection manager for travel router
+# travelmate shared function library/include, a wlan connection manager for travel router
# Copyright (c) 2016-2025 Dirk Brenken (dev@brenken.org)
# This is free software, licensed under the GNU General Public License v3.
# set (s)hellcheck exceptions
# shellcheck disable=all
+# initial defaults
+#
export LC_ALL=C
export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
trm_enabled="0"
trm_debug="0"
-trm_iface=""
trm_laniface=""
trm_captive="1"
trm_proactive="0"
trm_autoadd="0"
trm_randomize="0"
trm_mail="0"
-trm_mailpgm="/etc/travelmate/travelmate.mail"
+trm_mailtemplate="/etc/travelmate/mail.template"
trm_vpnpgm="/etc/travelmate/travelmate.vpn"
trm_minquality="35"
trm_maxretry="3"
trm_rtfile="/tmp/trm_runtime.json"
trm_captiveurl="http://detectportal.firefox.com"
trm_useragent="Mozilla/5.0 (X11; Linux x86_64; rv:144.0) Gecko/20100101 Firefox/144.0"
-trm_ntpfile="/var/state/travelmate.ntp"
+trm_ntplock="/var/lock/travelmate.ntp.lock"
trm_vpnfile="/var/state/travelmate.vpn"
trm_mailfile="/var/state/travelmate.mail"
trm_refreshfile="/var/state/travelmate.refresh"
trm_pidfile="/var/run/travelmate.pid"
-trm_action="${1:-"start"}"
+
+# gather system information
+#
+f_system() {
+ trm_packages="$("${trm_ubuscmd}" -S call rpc-sys packagelist '{ "all": true }' 2>/dev/null)"
+ trm_fver="$(printf "%s" "${trm_packages}" | "${trm_jsoncmd}" -ql1 -e '@.packages["luci-app-travelmate"]')"
+ trm_bver="$(printf "%s" "${trm_packages}" | "${trm_jsoncmd}" -ql1 -e '@.packages.travelmate')"
+ trm_sysver="$("${trm_ubuscmd}" -S call system board 2>/dev/null |
+ "${trm_jsoncmd}" -ql1 -e '@.model' -e '@.release.target' -e '@.release.distribution' -e '@.release.version' -e '@.release.revision' |
+ "${trm_awkcmd}" 'BEGIN{RS="";FS="\n"}{printf "%s, %s, %s %s (%s)",$1,$2,$3,$4,$5}')"
+
+ if [ ! -d "${trm_ntplock}" ]; then
+ "${trm_ubuscmd}" -S call hotplug.ntp call '{ "env": [ "ACTION=stratum" ] }' >/dev/null 2>&1
+ fi
+}
# command selector
#
# load travelmate environment
#
-f_env() {
- if [ "${trm_action}" = "stop" ]; then
- return
- fi
+f_conf() {
+ local device
- unset trm_stalist trm_radiolist trm_uplinklist trm_vpnifacelist trm_uplinkcfg trm_activesta trm_opensta trm_ssidfilter
-
- trm_sysver="$("${trm_ubuscmd}" -S call system board 2>/dev/null | "${trm_jsoncmd}" -ql1 -e '@.model' -e '@.release.target' -e '@.release.distribution' -e '@.release.version' -e '@.release.revision' |
- "${trm_awkcmd}" 'BEGIN{RS="";FS="\n"}{printf "%s, %s, %s %s %s %s",$1,$2,$3,$4,$5,$6}')"
+ [ "${trm_action}" = "stop" ] && return 0
+ unset trm_stalist trm_radiolist trm_uplinklist trm_vpnifacelist trm_uplinkcfg trm_activesta trm_opensta trm_ssidfilter
config_cb() {
local name="${1}" type="${2}"
if [ "${name}" = "travelmate" ] && [ "${type}" = "global" ]; then
option_cb() {
local option="${1}" value="${2//\"/\\\"}"
- eval "${option}=\"${value}\""
+
+ case "${option}" in
+ *[!a-zA-Z0-9_]*)
+ ;;
+ *)
+ eval "${option}=\"\${value}\""
+ ;;
+ esac
}
list_cb() {
local option="${1}" value="${2//\"/\\\"}"
- if [ "${option}" = "trm_vpnifacelist" ] && ! printf "%s" "${trm_vpnifacelist}" | "${trm_grepcmd}" -q "${value}"; then
- eval "trm_vpnifacelist=\"$(printf "%s" "${trm_vpnifacelist}") ${value}\""
- elif [ "${option}" = "trm_ssidfilter" ] && ! printf "%s" "${trm_ssidfilter}" | "${trm_grepcmd}" -q "${value}"; then
- eval "trm_ssidfilter=\"$(printf "%s" "${trm_ssidfilter}") ${value}\""
- fi
+
+ case "${option}" in
+ trm_vpnifacelist)
+ case " ${trm_vpnifacelist} " in
+ *" ${value} "*)
+ ;;
+ *)
+ trm_vpnifacelist="${trm_vpnifacelist} ${value}"
+ ;;
+ esac
+ ;;
+ trm_ssidfilter)
+ case " ${trm_ssidfilter} " in
+ *" ${value} "*)
+ ;;
+ *)
+ trm_ssidfilter="${trm_ssidfilter} ${value}"
+ ;;
+ esac
+ ;;
+ esac
}
elif [ "${name}" = "uplink" ]; then
if [ "$(uci_get "travelmate.${type}.opensta")" = "1" ]; then
- eval "trm_opensta=\"$((${trm_opensta:-0} + 1))\""
+ trm_opensta="$((${trm_opensta:-0} + 1))"
fi
- else
- option_cb() {
- return 0
- }
fi
}
config_load travelmate
f_log "info" "travelmate is currently disabled, please set 'trm_enabled' to '1' to use this service"
/etc/init.d/travelmate stop
elif [ -z "${trm_iface}" ]; then
- f_log "info" "travelmate is currently not configured, please use the 'Interface Setup' in LuCI or the 'setup' option in CLI"
+ f_log "info" "travelmate is currently not configured, please use the 'Interface Wizard' in LuCI"
/etc/init.d/travelmate stop
elif ! "${trm_ubuscmd}" -t "${trm_maxwait}" wait_for network.wireless network.interface."${trm_iface}" >/dev/null 2>&1; then
f_log "info" "travelmate interface '${trm_iface}' does not appear on ubus, please check your network setup"
json_init
json_add_object "data"
fi
-
+
if [ "${trm_vpn}" = "1" ] && [ -z "${trm_vpninfolist}" ]; then
config_load network
config_foreach f_getvpn "interface"
fi
- f_log "debug" "f_env ::: fetch: ${trm_fetchcmd}, sys_ver: ${trm_sysver}"
+
+ trm_fetchparm="--silent --show-error --location --fail --referer http://www.example.com --retry $((trm_maxwait / 6)) --retry-delay $((trm_maxwait / 6)) --max-time $((trm_maxwait / 6))"
+ device="$("${trm_ifstatuscmd}" "${trm_iface}" | "${trm_jsoncmd}" -ql1 -e '@.device')"
+ [ -n "${device}" ] && trm_fetchparm="${trm_fetchparm} --interface ${device}"
+
+ f_log "debug" "f_conf ::: frontend: ${trm_fver}, backend: ${trm_bver}, sys_ver: ${trm_sysver}, fetch_parm: ${trm_fetchparm:-"-"}"
+}
+
+f_rmpid() {
+ local ppid pid
+
+ if [ -s "${trm_pidfile}" ]; then
+ ppid="$("${trm_catcmd}" "${trm_pidfile}" 2>/dev/null)"
+ if [ -n "${ppid}" ]; then
+ pid="$("${trm_pgrepcmd}" -nf "sleep ${trm_timeout} 0" -P ${ppid} 2>/dev/null)"
+ [ -n "${pid}" ] && "${trm_killcmd}" -INT ${pid} 2>/dev/null
+ fi
+ fi
+ f_log "debug" "f_rmpid ::: ppid: ${ppid:-"-"}, pid: ${pid:-"-"}, timeout: ${trm_timeout}"
}
# trim helper function
f_char() {
local result input="${1}"
- if [ "${input}" = "1" ]; then
- result="✔"
- else
- result="✘"
- fi
+ [ "${input}" = "1" ] && result="✔" || result="✘"
printf "%s" "${result}"
}
sleep "$((trm_maxwait / 6))"
timeout="$((timeout + (trm_maxwait / 6)))"
fi
- f_log "debug" "f_wifi ::: radio_list: ${trm_radiolist}, ssid_filter: ${trm_ssidfilter:-"-"}, radio: ${radio}, timeout: ${timeout}"
+ f_log "debug" "f_wifi ::: radio_list: ${trm_radiolist}, ssid_filter: ${trm_ssidfilter:-"-"}, radio: ${radio}, timeout: ${timeout}"
}
# vpn helper function
if [ ! -f "${trm_vpnfile}" ] || { [ -f "${trm_vpnfile}" ] && [ "${vpn_action}" = "enable" ]; }; then
for info in ${trm_vpninfolist}; do
iface="${info%%&&*}"
- vpn_status="$(ifstatus "${iface}" | "${trm_jsoncmd}" -ql1 -e '@.up')"
+ vpn_status="$("${trm_ifstatuscmd}" "${iface}" | "${trm_jsoncmd}" -ql1 -e '@.up')"
if [ "${vpn_status}" = "true" ]; then
/sbin/ifdown "${iface}"
"${trm_ubuscmd}" -S call network.interface."${iface}" remove >/dev/null 2>&1
for info in ${trm_vpninfolist}; do
iface="${info%%&&*}"
[ "${iface}" = "${info}" ] && vpn_instance="" || vpn_instance="${info##*&&}"
- vpn_status="$(ifstatus "${iface}" | "${trm_jsoncmd}" -ql1 -e '@.up')"
+ vpn_status="$("${trm_ifstatuscmd}" "${iface}" | "${trm_jsoncmd}" -ql1 -e '@.up')"
if [ "${vpn_status}" = "true" ] && [ "${iface}" != "${vpn_iface}" ]; then
/sbin/ifdown "${iface}"
f_log "info" "take down vpn interface '${iface}' (switch)"
fi
if [ -x "${trm_vpnpgm}" ] && [ -n "${vpn_service}" ] && [ -n "${vpn_iface}" ]; then
if { [ "${vpn_action}" = "disable" ] && [ -f "${trm_vpnfile}" ]; } ||
- { [ -s "${trm_ntpfile}" ] && { [ "${vpn}" = "1" ] && [ "${vpn_action%%_*}" = "enable" ] && [ ! -f "${trm_vpnfile}" ]; } ||
+ { [ -d "${trm_ntplock}" ] && { [ "${vpn}" = "1" ] && [ "${vpn_action%%_*}" = "enable" ] && [ ! -f "${trm_vpnfile}" ]; } ||
{ [ "${vpn}" != "1" ] && [ "${vpn_action%%_*}" = "enable" ] && [ -f "${trm_vpnfile}" ]; }; }; then
if [ "${trm_connection%%/*}" = "net ok" ] || [ "${vpn_action}" = "disable" ]; then
for info in ${trm_vpninfolist}; do
iface="${info%%&&*}"
- if [ "${iface}" = "${vpn_iface}" ]; then
+ if [ "${iface}" = "${vpn_iface}" ]; then
[ "${iface}" = "${info}" ] && vpn_instance="" || vpn_instance="${info##*&&}"
break
fi
rc="${?}"
fi
fi
- [ -n "${rc}" ] && f_jsnup
+ [ -n "${rc}" ] && f_genstatus
fi
fi
- f_log "debug" "f_vpn ::: vpn: ${trm_vpn:-"-"}, enabled: ${vpn:-"-"}, action: ${vpn_action}, vpn_service: ${vpn_service:-"-"}, vpn_iface: ${vpn_iface:-"-"}, vpn_instance: ${vpn_instance:-"-"}, vpn_infolist: ${trm_vpninfolist:-"-"}, connection: ${trm_connection%%/*}, rc: ${rc:-"-"}"
+ f_log "debug" "f_vpn ::: vpn: ${trm_vpn:-"-"}, enabled: ${vpn:-"-"}, action: ${vpn_action}, vpn_service: ${vpn_service:-"-"}, vpn_iface: ${vpn_iface:-"-"}, vpn_instance: ${vpn_instance:-"-"}, vpn_infolist: ${trm_vpninfolist:-"-"}, connection: ${trm_connection%%/*}, rc: ${rc:-"-"}"
}
# mac helper function
fi
fi
printf "%s" "${result}"
- f_log "debug" "f_mac ::: action: ${action:-"-"}, section: ${section:-"-"}, macaddr: ${macaddr:-"-"}, result: ${result:-"-"}"
+ f_log "debug" "f_mac ::: action: ${action:-"-"}, section: ${section:-"-"}, macaddr: ${macaddr:-"-"}, result: ${result:-"-"}"
}
# set connection information
"start")
uci_remove "travelmate" "${trm_uplinkcfg}" "con_start" 2>/dev/null
uci_remove "travelmate" "${trm_uplinkcfg}" "con_end" 2>/dev/null
- if [ -s "${trm_ntpfile}" ]; then
+ if [ -d "${trm_ntplock}" ]; then
uci_set "travelmate" "${trm_uplinkcfg}" "con_start" "$(date "+%Y.%m.%d-%H:%M:%S")"
fi
;;
"refresh")
- if [ -s "${trm_ntpfile}" ] && [ -z "$(uci_get "travelmate" "${trm_uplinkcfg}" "con_start")" ]; then
+ if [ -d "${trm_ntplock}" ] && [ -z "$(uci_get "travelmate" "${trm_uplinkcfg}" "con_start")" ]; then
uci_set "travelmate" "${trm_uplinkcfg}" "con_start" "$(date "+%Y.%m.%d-%H:%M:%S")"
fi
;;
"end")
- if [ -s "${trm_ntpfile}" ]; then
+ if [ -d "${trm_ntplock}" ]; then
uci_set "travelmate" "${trm_uplinkcfg}" "con_end" "$(date "+%Y.%m.%d-%H:%M:%S")"
fi
;;
"start_expiry")
- if [ -s "${trm_ntpfile}" ]; then
+ if [ -d "${trm_ntplock}" ]; then
expiry="$(uci_get "travelmate" "${trm_uplinkcfg}" "con_start_expiry")"
uci_set "travelmate" "${trm_uplinkcfg}" "enabled" "0"
uci_set "travelmate" "${trm_uplinkcfg}" "con_end" "$(date "+%Y.%m.%d-%H:%M:%S")"
fi
;;
"end_expiry")
- if [ -s "${trm_ntpfile}" ]; then
+ if [ -d "${trm_ntplock}" ]; then
expiry="$(uci_get "travelmate" "${trm_uplinkcfg}" "con_end_expiry")"
uci_set "travelmate" "${trm_uplinkcfg}" "enabled" "1"
uci_remove "travelmate" "${trm_uplinkcfg}" "con_start" 2>/dev/null
;;
"disabled")
uci_set "travelmate" "${trm_uplinkcfg}" "enabled" "0"
- if [ -s "${trm_ntpfile}" ]; then
+ if [ -d "${trm_ntplock}" ]; then
uci_set "travelmate" "${trm_uplinkcfg}" "con_end" "$(date "+%Y.%m.%d-%H:%M:%S")"
fi
;;
fi
fi
fi
- f_log "debug" "f_ctrack ::: uplink_config: ${trm_uplinkcfg:-"-"}, action: ${action:-"-"}"
+ f_log "debug" "f_ctrack ::: uplink_config: ${trm_uplinkcfg:-"-"}, action: ${action:-"-"}"
}
# get openvpn information
config_load openvpn
config_foreach uci_config "openvpn"
fi
- f_log "debug" "f_getovpn ::: ovpn_infolist: ${trm_ovpninfolist:-"-"}"
+ f_log "debug" "f_getovpn ::: ovpn_infolist: ${trm_ovpninfolist:-"-"}"
}
# get logical vpn network interfaces
done
fi
fi
- f_log "debug" "f_getvpn ::: iface: ${iface:-"-"}, proto: ${proto:-"-"}, device: ${device:-"-"}, vpn_ifacelist: ${trm_vpnifacelist:-"-"}, vpn_infolist: ${trm_vpninfolist:-"-"}"
+ f_log "debug" "f_getvpn ::: iface: ${iface:-"-"}, proto: ${proto:-"-"}, device: ${device:-"-"}, vpn_ifacelist: ${trm_vpnifacelist:-"-"}, vpn_infolist: ${trm_vpninfolist:-"-"}"
}
# get wan gateway addresses
#
f_getgw() {
- local result wan4_if wan4_gw wan6_if wan6_gw
+ local wan4_if wan4_gw wan6_if wan6_gw result="false"
network_flush_cache
network_find_wan wan4_if
result="true"
fi
printf "%s" "${result}"
- f_log "debug" "f_getgw ::: wan4_gw: ${wan4_gw:-"-"}, wan6_gw: ${wan6_gw:-"-"}, result: ${result:-"-"}"
+ f_log "debug" "f_getgw ::: wan4_gw: ${wan4_gw:-"-"}, wan6_gw: ${wan6_gw:-"-"}, result: ${result}"
}
# get uplink config section
fi
cnt="$((cnt + 1))"
done
- f_log "debug" "f_getcfg ::: uplink_config: ${trm_uplinkcfg:-"-"}"
+ f_log "debug" "f_getcfg ::: uplink_config: ${trm_uplinkcfg:-"-"}"
}
# get travelmate option value in 'uplink' sections
result="$(uci_get "travelmate" "${trm_uplinkcfg}" "${t_option}")"
printf "%s" "${result}"
fi
- f_log "debug" "f_getval ::: uplink_config: ${trm_uplinkcfg:-"-"}, option: ${t_option:-"-"}, result: ${result:-"-"}"
+ f_log "debug" "f_getval ::: uplink_config: ${trm_uplinkcfg:-"-"}, option: ${t_option:-"-"}, result: ${result:-"-"}"
}
# set 'wifi-device' sections
uci_set wireless "${radio}" "disabled" "0"
fi
fi
- f_log "debug" "f_setdev ::: device: ${radio:-"-"}, radio: ${trm_radio:-"-"}, radio_list: ${trm_radiolist:-"-"}, disabled: ${disabled:-"-"}"
+ f_log "debug" "f_setdev ::: device: ${radio:-"-"}, radio: ${trm_radio:-"-"}, radio_list: ${trm_radiolist:-"-"}, disabled: ${disabled:-"-"}"
}
# set 'wifi-iface' sections
trm_stalist="$(f_trim "${trm_stalist} ${section}-${radio}")"
fi
fi
- f_log "debug" "f_setif ::: uplink_config: ${trm_uplinkcfg:-"-"}, section: ${section}, enabled: ${enabled}, active_sta: ${trm_activesta:-"-"}"
+ f_log "debug" "f_setif ::: uplink_config: ${trm_uplinkcfg:-"-"}, section: ${section}, enabled: ${enabled}, active_sta: ${trm_activesta:-"-"}"
}
# check router/uplink subnet
f_log "info" "uplink network '${wan_net}' conflicts with router LAN network, please adjust your network settings"
fi
printf "%s" "${wan_net:-"-"} (lan: ${lan_net:-"-"})"
- f_log "debug" "f_subnet ::: lan_net: ${lan_net:-"-"}, wan_net: ${wan_net:-"-"}"
+ f_log "debug" "f_subnet ::: lan_net: ${lan_net:-"-"}, wan_net: ${wan_net:-"-"}"
}
# add open uplinks
f_log "info" "open uplink '${radio}/${essid}' added to wireless config"
printf "%s" "${wifi_cfg}-${radio}"
fi
- f_log "debug" "f_addsta ::: radio: ${radio:-"-"}, essid: ${essid}, opensta/maxautoadd: ${trm_opensta:-"-"}/${trm_maxautoadd:-"-"}, new_uplink: ${new_uplink}, offset: ${offset}"
+ f_log "debug" "f_addsta ::: radio: ${radio:-"-"}, essid: ${essid}, opensta/maxautoadd: ${trm_opensta:-"-"}/${trm_maxautoadd:-"-"}, new_uplink: ${new_uplink}, offset: ${offset}"
}
# check net status
f_net() {
local err_msg raw json_raw html_raw html_cp js_cp json_ec json_rc json_cp json_ed result="net nok"
- raw="$("${trm_fetchcmd}" --user-agent "${trm_useragent}" --referer "http://www.example.com" --header "Cache-Control: no-cache, no-store, must-revalidate, max-age=0" --write-out "%{json}" --silent --retry $((trm_maxwait / 6)) --max-time $((trm_maxwait / 6)) "${trm_captiveurl}")"
+ raw="$("${trm_fetchcmd}" ${trm_fetchparm} --user-agent "${trm_useragent}" --header "Cache-Control: no-cache, no-store, must-revalidate, max-age=0" --write-out "%{json}" "${trm_captiveurl}")"
json_raw="${raw#*\{}"
html_raw="${raw%%\{*}"
if [ -n "${json_raw}" ]; then
fi
fi
printf "%s" "${result}"
- f_log "debug" "f_net ::: timeout: $((trm_maxwait / 6)), cp (json/html/js): ${json_cp:-"-"}/${html_cp:-"-"}/${js_cp:-"-"}, result: ${result}, error (rc/msg): ${json_ec}/${err_msg:-"-"}, url: ${trm_captiveurl}"
+ f_log "debug" "f_net ::: timeout: $((trm_maxwait / 6)), cp (json/html/js): ${json_cp:-"-"}/${html_cp:-"-"}/${js_cp:-"-"}, result: ${result}, error (rc/msg): ${json_ec}/${err_msg:-"-"}, url: ${trm_captiveurl}"
}
# check interface status
if [ "${mode}" = "dev" ]; then
if [ "${trm_ifstatus}" != "${status}" ]; then
trm_ifstatus="${status}"
- f_jsnup
+ f_genstatus
fi
if [ "${status}" = "false" ]; then
sleep "$((trm_maxwait / 6))"
trm_connection=""
trm_ifstatus="${status}"
f_ctrack "end"
- f_jsnup
+ f_genstatus
break
fi
continue
[ -n "$(uci -q changes "dhcp")" ] && uci_commit "dhcp"
/etc/init.d/dnsmasq reload
f_log "info" "captive portal domain '${cp_domain}' added to to dhcp rebind whitelist"
- else
+ else
break
fi
result="$(f_net)"
done
if [ -n "${cp_domain}" ]; then
trm_connection="${result:-"-"}/${trm_ifquality}"
- f_jsnup
+ f_genstatus
login_script="$(f_getval "script")"
if [ -x "${login_script}" ]; then
login_script_args="$(f_getval "script_args")"
if [ "${trm_netcheck}" = "1" ]; then
f_log "info" "uplink has no internet"
trm_ifstatus="${status}"
- f_jsnup
+ f_genstatus
break
fi
fi
trm_connection="${result:-"-"}/${trm_ifquality}"
- f_jsnup
+ f_genstatus
break
fi
elif [ -n "${trm_connection}" ] && { [ "${trm_netcheck}" = "1" ] || [ "${mode}" = "initial" ]; }; then
trm_connection=""
trm_ifstatus="${status}"
f_ctrack "end"
- f_jsnup
+ f_genstatus
break
elif [ "${mode}" = "initial" ] || [ "${mode}" = "sta" ]; then
trm_connection=""
trm_ifstatus="${status}"
- f_jsnup
+ f_genstatus
break
fi
elif [ -n "${trm_connection}" ]; then
f_vpn "disable"
trm_connection=""
trm_ifstatus="${status}"
- f_jsnup
+ f_genstatus
break
elif [ "${mode}" = "initial" ]; then
trm_ifstatus="${status}"
- f_jsnup
+ f_genstatus
break
fi
fi
fi
if [ "${mode}" = "initial" ]; then
trm_ifstatus="${status}"
- f_jsnup
+ f_genstatus
break
fi
done
- f_log "debug" "f_check ::: mode: ${mode}, name: ${ifname:-"-"}, status: ${trm_ifstatus}, enabled: ${enabled}, connection: ${trm_connection:-"-"}, wait: ${wait_time}, max_wait: ${trm_maxwait}, min_quality/quality: ${trm_minquality}/${trm_ifquality:-"-"}, captive: ${trm_captive}, netcheck: ${trm_netcheck}"
+ f_log "debug" "f_check ::: mode: ${mode}, name: ${ifname:-"-"}, status: ${trm_ifstatus}, enabled: ${enabled}, connection: ${trm_connection:-"-"}, wait: ${wait_time}, max_wait: ${trm_maxwait}, min_quality/quality: ${trm_minquality}/${trm_ifquality:-"-"}, captive: ${trm_captive}, netcheck: ${trm_netcheck}"
}
-# update runtime information
+# get status information
#
-f_jsnup() {
- local vpn vpn_iface section last_date sta_iface sta_radio sta_essid sta_bssid sta_mac dev_status status="${trm_ifstatus}" ntp_done="0" vpn_done="0" mail_done="0"
+f_getstatus() {
+ local key keylist value rtfile
+
+ rtfile="$(uci_get travelmate global trm_rtfile "/tmp/trm_runtime.json")"
+ json_load_file "${rtfile}" >/dev/null 2>&1
+ if json_select data >/dev/null 2>&1; then
+ printf "%s\n" "::: travelmate runtime information"
+ json_get_keys keylist
+ for key in ${keylist}; do
+ json_get_var value "${key}"
+ printf " + %-18s : %s\n" "${key}" "${value}"
+ done
+ else
+ printf "%s\n" "::: no travelmate runtime information available"
+ fi
+}
+# generate status information
+#
+f_genstatus() {
+ local vpn vpn_iface section last_date sta_iface sta_radio sta_essid sta_bssid sta_mac dev_status status="${trm_ifstatus}" ntp_done="0" vpn_done="0" mail_done="0"
+#set -x
if [ "${status}" = "true" ]; then
- status="connected (${trm_connection:-"-"})"
+ status="connected, ${trm_connection:-"-"}"
dev_status="$("${trm_ubuscmd}" -S call network.wireless status 2>/dev/null)"
section="$(printf "%s" "${dev_status}" | "${trm_jsoncmd}" -ql1 -e '@.*.interfaces[@.config.mode="sta"].section')"
if [ -n "${section}" ]; then
vpn="$(f_getval "vpn")"
if [ "${trm_vpn}" = "1" ] && [ -n "${trm_vpninfolist}" ] && [ "${vpn}" = "1" ] && [ -f "${trm_vpnfile}" ]; then
- vpn_iface="$(f_getval "vpniface")"
+ vpn_iface="$(f_getval "vpniface")"
vpn_done="1"
fi
elif [ "${status}" = "error" ]; then
status="program error"
else
trm_connection=""
- status="running (not connected)"
+ status="running, not connected"
fi
if [ -z "${last_date}" ]; then
last_date="$(date "+%Y.%m.%d-%H:%M:%S")"
fi
- if [ -s "${trm_ntpfile}" ]; then
+ if [ -d "${trm_ntplock}" ]; then
ntp_done="1"
fi
if [ "${trm_mail}" = "1" ] && [ -f "${trm_mailfile}" ]; then
mail_done="1"
fi
json_add_string "travelmate_status" "${status}"
- json_add_string "travelmate_version" "${trm_ver}"
+ json_add_string "frontend_ver" "${trm_fver}"
+ json_add_string "backend_ver" "${trm_bver}"
json_add_string "station_id" "${sta_radio:-"-"}/${sta_essid:-"-"}/${sta_bssid:-"-"}"
json_add_string "station_mac" "${sta_mac:-"-"}"
json_add_string "station_interfaces" "${sta_iface:-"-"}, ${vpn_iface:-"-"}"
json_add_string "system" "${trm_sysver}"
json_dump >"${trm_rtfile}"
- if [ "${status%% (net ok/*}" = "connected" ] && [ "${trm_mail}" = "1" ] && [ -x "${trm_mailpgm}" ] && [ "${ntp_done}" = "1" ] && [ "${mail_done}" = "0" ]; then
+ if [ "${status%%, net ok/*}" = "connected" ] && [ "${trm_mail}" = "1" ] &&
+ [ -x "${trm_mailcmd}" ] && [ -n "${trm_mailreceiver}" ] && [ "${ntp_done}" = "1" ] && [ "${mail_done}" = "0" ]; then
if [ "${trm_vpn}" != "1" ] || [ "${vpn}" != "1" ] || [ -z "${trm_vpninfolist}" ] || [ "${vpn_done}" = "1" ]; then
: >"${trm_mailfile}"
- "${trm_mailpgm}" >/dev/null 2>&1
+ mail_done="1"
+ f_mail
fi
fi
- f_log "debug" "f_jsnup ::: section: ${section:-"-"}, status: ${status:-"-"}, sta_iface: ${sta_iface:-"-"}, sta_radio: ${sta_radio:-"-"}, sta_essid: ${sta_essid:-"-"}, sta_bssid: ${sta_bssid:-"-"}, ntp: ${ntp_done}, vpn: ${vpn:-"0"}/${vpn_done}, mail: ${trm_mail}/${mail_done}"
+ #set +x
+ f_log "debug" "f_genstatus ::: section: ${section:-"-"}, status: ${status:-"-"}, sta_iface: ${sta_iface:-"-"}, sta_radio: ${sta_radio:-"-"}, sta_essid: ${sta_essid:-"-"}, sta_bssid: ${sta_bssid:-"-"}, ntp: ${ntp_done}, vpn: ${vpn:-"0"}/${vpn_done}, mail: ${trm_mail}/${mail_done}"
+}
+
+# send status mail
+#
+f_mail() {
+ local msmtp_debug mail_text
+
+ # load mail template
+ #
+ if [ -r "${trm_mailtemplate}" ]; then
+ . "${trm_mailtemplate}"
+ else
+ f_log "info" "no mail template"
+ fi
+ [ -z "${mail_text}" ] && f_log "info" "no mail content"
+ [ "${trm_debug}" = "1" ] && msmtp_debug="--debug"
+
+ # send mail
+ #
+ trm_mailhead="From: ${trm_mailsender}\nTo: ${trm_mailreceiver}\nSubject: ${trm_mailtopic}\nReply-to: ${trm_mailsender}\nMime-Version: 1.0\nContent-Type: text/html;charset=utf-8\nContent-Disposition: inline\n\n"
+ printf "%b" "${trm_mailhead}${mail_text}" | "${trm_mailcmd}" --timeout=10 ${msmtp_debug} -a "${trm_mailprofile}" "${trm_mailreceiver}" >/dev/null 2>&1
+
+ f_log "debug" "f_mail ::: notification: ${trm_mailnotification}, template: ${trm_mailtemplate}, profile: ${trm_mailprofile}, receiver: ${trm_mailreceiver}, rc: ${?}"
}
# write to syslog
local class="${1}" log_msg="${2}"
if [ -n "${log_msg}" ] && { [ "${class}" != "debug" ] || [ "${trm_debug}" = "1" ]; }; then
- if [ -x "${trm_loggercmd}" ]; then
- "${trm_loggercmd}" -p "${class}" -t "trm-${trm_ver}[${$}]" "${log_msg}"
+ if [ -x "${trm_logcmd}" ]; then
+ "${trm_logcmd}" -p "${class}" -t "trm-${trm_bver}[${$}]" "${log_msg::512}"
else
- printf "%s %s %s\n" "${class}" "trm-${trm_ver}[${$}]" "${log_msg}"
+ printf "%s %s %s\n" "${class}" "trm-${trm_bver}[${$}]" "${log_msg::512}"
fi
if [ "${class}" = "err" ]; then
trm_ifstatus="error"
- f_jsnup
+ f_genstatus
: >"${trm_pidfile}"
exit 1
fi
f_vpn "disable"
fi
fi
- f_log "debug" "f_main-1 ::: status: ${trm_ifstatus}, connection: ${trm_connection%%/*}, proactive: ${trm_proactive}"
+ f_log "debug" "f_main-1 ::: status: ${trm_ifstatus}, connection: ${trm_connection%%/*}, proactive: ${trm_proactive}"
if [ "${trm_ifstatus}" != "true" ] || [ "${trm_proactive}" = "1" ]; then
config_load wireless
config_foreach f_setif wifi-iface "${trm_proactive}"
config_bssid="${station_id##*/}"
config_bssid="${config_bssid//-/}"
f_check "dev" "true"
- f_log "debug" "f_main-2 ::: config_radio: ${config_radio}, config_essid: \"${config_essid}\", config_bssid: ${config_bssid:-"-"}"
+ f_log "debug" "f_main-2 ::: config_radio: ${config_radio}, config_essid: \"${config_essid}\", config_bssid: ${config_bssid:-"-"}"
else
[ -n "$(uci -q changes "wireless")" ] && uci_commit "wireless"
f_check "dev" "false"
fi
- f_log "debug" "f_main-3 ::: radio_list: ${trm_radiolist:-"-"}, sta_list: ${trm_stalist:-"-"}"
+ f_log "debug" "f_main-3 ::: radio_list: ${trm_radiolist:-"-"}, sta_list: ${trm_stalist:-"-"}"
# radio loop
#
[ "${sta_essid}" = "${config_essid}" ] && [ "${sta_bssid}" = "${config_bssid}" ]; then
f_ctrack "refresh"
f_vpn "enable_keep"
- f_log "debug" "f_main-4 ::: config_radio: ${config_radio}, config_essid: ${config_essid}, config_bssid: ${config_bssid:-"-"}"
+ f_log "debug" "f_main-4 ::: config_radio: ${config_radio}, config_essid: ${config_essid}, config_bssid: ${config_bssid:-"-"}"
return 0
fi
- f_log "debug" "f_main-5 ::: sta_radio: ${sta_radio}, sta_essid: \"${sta_essid}\", sta_bssid: ${sta_bssid:-"-"}"
+ f_log "debug" "f_main-5 ::: sta_radio: ${sta_radio}, sta_essid: \"${sta_essid}\", sta_bssid: ${sta_bssid:-"-"}"
fi
if [ -z "${scan_list}" ]; then
radio_num="${radio//[a-z]/}"
/WPA:/{wpa="+"}
/RSN:/{rsn="+"}
END{if(bssid!=""){if(ssid=="")ssid="unknown";printf "%s %s %s %s %s\n",signal,rsn,wpa,bssid,ssid}}' | "${trm_sortcmd}" -rn)")"
- f_log "debug" "f_main-6 ::: radio: ${radio}, scan_device: ${scan_dev}, scan_mode: ${trm_scanmode:-"active"}, scan_cnt: $(printf "%s" "${scan_list}" | "${trm_grepcmd}" -c "^")"
+ f_log "debug" "f_main-6 ::: radio: ${radio}, scan_device: ${scan_dev}, scan_mode: ${trm_scanmode:-"active"}, scan_cnt: $(printf "%s" "${scan_list}" | "${trm_grepcmd}" -c "^")"
if [ "${scan_dev}" = "trmscan${radio_num}" ]; then
"${trm_ipcmd}" link set "trmscan${radio_num}" down >/dev/null 2>&1
scan_open="-"
fi
if [ -n "${scan_quality}" ] && [ -n "${scan_open}" ] && [ -n "${scan_bssid}" ] && [ -n "${scan_essid}" ]; then
- f_log "debug" "f_main-7 ::: radio(sta/scan): ${sta_radio}/${radio}, essid(sta/scan): \"${sta_essid}\"/${scan_essid}, bssid(sta/scan): ${sta_bssid}/${scan_bssid}, quality(min/scan): ${trm_minquality}/${scan_quality}, open: ${scan_open}"
+ f_log "debug" "f_main-7 ::: radio(sta/scan): ${sta_radio}/${radio}, essid(sta/scan): \"${sta_essid}\"/${scan_essid}, bssid(sta/scan): ${sta_bssid}/${scan_bssid}, quality(min/scan): ${trm_minquality}/${scan_quality}, open: ${scan_open}"
if [ "${scan_quality}" -lt "${trm_minquality}" ]; then
continue 2
elif [ "${scan_quality}" -ge "${trm_minquality}" ]; then
f_log "info" "uplink has been disabled '${sta_radio}/${sta_essid}/${sta_bssid:-"-"}' (${retrycnt}/${trm_maxretry})"
continue 2
else
- f_jsnup
+ f_genstatus
f_log "info" "can't connect to uplink '${sta_radio}/${sta_essid}/${sta_bssid:-"-"}' (${retrycnt}/${trm_maxretry})"
fi
fi
# reference required system utilities
#
+trm_catcmd="$(f_cmd cat)"
trm_awkcmd="$(f_cmd gawk awk)"
trm_sortcmd="$(f_cmd sort)"
trm_grepcmd="$(f_cmd grep)"
+trm_pgrepcmd="$(f_cmd pgrep)"
+trm_sleepcmd="$(f_cmd sleep)"
+trm_killcmd="$(f_cmd kill)"
trm_jsoncmd="$(f_cmd jsonfilter)"
+trm_lookupcmd="$(f_cmd nslookup)"
trm_ubuscmd="$(f_cmd ubus)"
-trm_loggercmd="$(f_cmd logger)"
+trm_logcmd="$(f_cmd logger)"
trm_wificmd="$(f_cmd wifi)"
trm_fetchcmd="$(f_cmd curl)"
trm_ipcmd="$(f_cmd ip)"
trm_iwcmd="$(f_cmd iw)"
trm_wpacmd="$(f_cmd wpa_supplicant)"
+trm_ifstatuscmd="$(f_cmd ifstatus)"
trm_ipcalccmd="$(f_cmd ipcalc.sh)"
+trm_mailcmd="$(f_cmd msmtp optional)"
-# get travelmate version
-#
-trm_ver="$("${trm_ubuscmd}" -S call rpc-sys packagelist '{ "all": true }' 2>/dev/null | "${trm_jsoncmd}" -ql1 -e '@.packages.travelmate')"
-
-# force ntp hotplug event/time sync
-#
-if [ ! -s "${trm_ntpfile}" ]; then
- "${trm_ubuscmd}" -S call hotplug.ntp call '{ "env": [ "ACTION=stratum" ] }' >/dev/null 2>&1
+f_system
+if [ "${trm_action}" != "stop" ]; then
+ [ ! -d "/etc/travelmate" ] && f_log "err" "no travelmate config directory"
+ [ ! -r "/etc/config/travelmate" ] && f_log "err" "no travelmate config"
+ [ "$(uci_get travelmate global trm_enabled)" = "0" ] && f_log "err" "travelmate is disabled"
fi
-
-# control travelmate actions
-#
-while :; do
- if [ "${trm_action}" = "stop" ]; then
- if [ -s "${trm_pidfile}" ]; then
- f_log "info" "travelmate instance stopped ::: action: ${trm_action}, pid: $(cat ${trm_pidfile} 2>/dev/null)"
- : >"${trm_rtfile}"
- : >"${trm_pidfile}"
- fi
- break
- elif [ -n "${trm_action}" ]; then
- f_log "info" "travelmate instance started ::: action: ${trm_action}, pid: ${$}"
- f_env
- f_main
- trm_action=""
- fi
- while :; do
- sleep "${trm_timeout}" 0
- rc="${?}"
- if [ "${rc}" != "0" ]; then
- if [ -z "$(f_getgw)" ]; then
- rc="0"
- fi
- fi
- if [ "${rc}" = "0" ]; then
- break
- fi
- done
- json_cleanup
- f_env
- f_main
-done
--- /dev/null
+#!/bin/sh
+# travelmate service script, a wlan connection manager for travel router
+# Copyright (c) 2016-2025 Dirk Brenken (dev@brenken.org)
+# This is free software, licensed under the GNU General Public License v3.
+
+# set (s)hellcheck exceptions
+# shellcheck disable=all
+
+# initial defaults
+#
+export LC_ALL=C
+export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
+trm_funlib="/usr/lib/travelmate-functions.sh"
+trm_action="${1}"
+[ -z "${trm_bver}" ] && . "${trm_funlib}"
+f_conf
+
+# control travelmate actions
+#
+while :; do
+ if [ "${trm_action}" = "stop" ]; then
+ if [ -s "${trm_pidfile}" ]; then
+ f_log "info" "travelmate instance stopped ::: action: ${trm_action}, pid: $(cat ${trm_pidfile} 2>/dev/null)"
+ : >"${trm_rtfile}"
+ : >"${trm_pidfile}"
+ fi
+ break
+ elif [ -n "${trm_action}" ]; then
+ f_log "info" "travelmate instance started ::: action: ${trm_action}, pid: ${$}"
+ f_main
+ trm_action=""
+ fi
+ while :; do
+ "${trm_sleepcmd}" "${trm_timeout}" 0 >/dev/null 2>&1
+ rc="${?}"
+ if [ "${rc}" != "0" ]; then
+ [ "$(f_getgw)" = "false" ] && rc="0"
+ fi
+ [ "${rc}" = "0" ] && break
+ done
+ json_cleanup
+ f_conf
+ f_main
+done
extra_command "setup" "[<iface>] [<zone>] [<metric>] Setup the travelmate uplink interface, by default 'trm_wwan' with firewall zone 'wan' and metric '100'"
trm_init="/etc/init.d/travelmate"
-trm_script="/usr/bin/travelmate.sh"
+trm_service="/usr/bin/travelmate-service.sh"
+trm_funlib="/usr/lib/travelmate-functions.sh"
trm_pidfile="/var/run/travelmate.pid"
trm_scanfile="/var/run/travelmate.scan"
+if [ -z "${IPKG_INSTROOT}" ]; then
+ if [ "${action}" = "boot" ] && "${trm_init}" running; then
+ exit 0
+ fi
+ . "${trm_funlib}"
+fi
+
boot() {
if [ -s "${trm_pidfile}" ]; then
: >"${trm_pidfile}"
return 0
fi
procd_open_instance "travelmate"
- procd_set_param command "${trm_script}" "${@}"
+ procd_set_param command "${trm_service}" "${@:-"${action}"}"
procd_set_param pidfile "${trm_pidfile}"
procd_set_param nice "$(uci_get travelmate global trm_nice "0")"
procd_set_param stdout 0
procd_set_param stderr 1
procd_close_instance
+ else
+ f_log "err" "travelmate service autostart is disabled"
fi
}
reload_service() {
- local ppid pid timeout
-
- timeout="$(uci_get travelmate global trm_timeout)"
-
- if [ -s "${trm_pidfile}" ]; then
- ppid="$(cat "${trm_pidfile}" 2>/dev/null)"
- if [ -n "${ppid}" ]; then
- pid="$(pgrep -xnf "sleep ${timeout:-60} 0" -P ${ppid} 2>/dev/null)"
- if [ -n "${pid}" ]; then
- kill -INT ${pid} 2>/dev/null
- fi
- fi
- fi
+ f_rmpid
}
stop_service() {
- rc_procd "${trm_script}" stop
+ rc_procd "${trm_service}" stop
}
status_service() {
- local key keylist value rtfile
-
- rtfile="$(uci_get travelmate global trm_rtfile "/tmp/trm_runtime.json")"
- json_load_file "${rtfile}" >/dev/null 2>&1
- if json_select data >/dev/null 2>&1; then
- printf "%s\n" "::: travelmate runtime information"
- json_get_keys keylist
- for key in ${keylist}; do
- json_get_var value "${key}"
- printf " + %-18s : %s\n" "${key}" "${value}"
- done
- else
- printf "%s\n" "::: no travelmate runtime information available"
- fi
+ f_getstatus
}
scan() {
}
setup() {
- local iface cnt=0 input="${1:-"trm_wwan"}" zone="${2:-"wan"}" metric="${3:-"100"}"
+ local rc cnt net iface input="${1:-"trm_wwan"}" zone="${2:-"wan"}" metric="${3:-"100"}"
- iface="$(uci_get travelmate global trm_iface)"
input="${input//[+*~%&\$@\"\' ]/}"
zone="${zone//[+*~%&\$@\"\' ]/}"
metric="${metric//[^0-9]/}"
-
+ iface="$(uci_get travelmate global trm_iface)"
+
if [ -n "${iface}" ] && [ "${iface}" = "${input}" ]; then
return 1
- elif [ -n "${input}" ]; then
- if [ -n "${iface}" ]; then
- uci -q batch <<-EOC
- del network."${iface}"
- del network."${iface}6"
- EOC
- fi
+ fi
+
+ if [ -n "$(uci_get network ${input})" ]; then
+ uci -q batch <<-EOC
+ set travelmate.global.trm_enabled="1"
+ set travelmate.global.trm_iface="${input}"
+ commit travelmate
+ EOC
+ rc="0"
+ else
uci -q batch <<-EOC
set travelmate.global.trm_enabled="1"
set travelmate.global.trm_iface="${input}"
- set network."${input}"="interface"
- set network."${input}".proto="dhcp"
- set network."${input}".metric="${metric}"
- set network."${input}6"=interface
- set network."${input}6".device="@${input}"
- set network."${input}6".proto="dhcpv6"
+ set network.${input}="interface"
+ set network.${input}.proto="dhcp"
+ set network.${input}.metric="${metric}"
+ set network.${input}6="interface"
+ set network.${input}6.device="@${input}"
+ set network.${input}6.proto="dhcpv6"
commit travelmate
commit network
EOC
+ rc="0"
+ fi
- while [ -n "$(uci -q get firewall.@zone["${cnt}"].name)" ]; do
- if [ "$(uci -q get firewall.@zone["${cnt}"].name)" = "${zone}" ]; then
- if [ -n "${iface}" ]; then
- uci -q batch <<-EOC
- del_list firewall.@zone["${cnt}"].network="${iface}"
- del_list firewall.@zone["${cnt}"].network="${iface}6"
- EOC
- fi
- uci -q batch <<-EOC
- add_list firewall.@zone["${cnt}"].network="${input}"
- add_list firewall.@zone["${cnt}"].network="${input}6"
- commit firewall
- EOC
- break
+ cnt="0"
+ while [ -n "$(uci_get firewall @zone[${cnt}] name)" ]; do
+ if [ "$(uci_get firewall @zone[${cnt}] name)" = "${zone}" ]; then
+ net="$(uci_get firewall @zone[${cnt}] network)"
+ if ! printf "%s" "${net}" | grep -qw "${input}"; then
+ uci -q add_list firewall.@zone[${cnt}].network="${input}"
+ fi
+ if ! printf "%s" "${net}" | grep -qw "${input}6"; then
+ uci -q add_list firewall.@zone[${cnt}].network="${input}6"
fi
- cnt=$((cnt + 1))
- done
-
- if [ -n "${iface}" ]; then
- cnt=0
- while [ -n "$(uci -q get wireless.@wifi-iface["${cnt}"].network)" ]; do
- if [ "$(uci -q get wireless.@wifi-iface["${cnt}"].network)" = "${iface}" ]; then
- uci -q set wireless.@wifi-iface["${cnt}"].network="${input}"
- fi
- cnt=$((cnt + 1))
- done
- uci -q commit wireless
+ [ -n "$(uci -q changes "firewall")" ] && uci_commit firewall
+ break
fi
- /etc/init.d/network reload >/dev/null 2>&1
- /etc/init.d/firewall reload >/dev/null 2>&1
- "${trm_init}" restart
- fi
+ cnt="$((cnt + 1))"
+ done
+
+ cnt="0"
+ while uci -q show wireless.@wifi-iface[${cnt}] >/dev/null 2>&1; do
+ if uci -q show wireless.@wifi-iface[${cnt}] | grep -qE "^wireless.trm_uplink[0-9]+="; then
+ uci_set wireless @wifi-iface[${cnt}] network "${input}"
+ fi
+ cnt="$((cnt + 1))"
+ done
+ [ -n "$(uci -q changes "wireless")" ] && uci_commit wireless
+
+ /etc/init.d/network reload >/dev/null 2>&1
+ /etc/init.d/firewall reload >/dev/null 2>&1
+ "${trm_init}" restart
+ return "${rc}"
}
service_triggers() {
+++ /dev/null
-#!/bin/sh
-# send mail script for travelmate notifications
-# Copyright (c) 2020-2024 Dirk Brenken (dev@brenken.org)
-# This is free software, licensed under the GNU General Public License v3.
-
-# set (s)hellcheck exceptions
-# shellcheck disable=all
-
-# Please note: you have to setup the package 'msmtp' before using this script
-
-. "/lib/functions.sh"
-
-export LC_ALL=C
-export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
-trm_debug="$(uci_get travelmate global trm_debug "0")"
-trm_mailreceiver="$(uci_get travelmate global trm_mailreceiver)"
-trm_mailprofile="$(uci_get travelmate global trm_mailprofile "trm_notify")"
-trm_mailsender="$(uci_get travelmate global trm_mailsender "no-reply@travelmate")"
-trm_rtfile="$(uci_get travelmate global trm_rtfile "/tmp/trm_runtime.json")"
-trm_mailcmd="$(command -v msmtp)"
-trm_ubuscmd="$(command -v ubus)"
-trm_jsoncmd="$(command -v jsonfilter)"
-trm_logger="$(command -v logger)"
-trm_ver="$("${trm_ubuscmd}" -S call rpc-sys packagelist '{ "all": true }' 2>/dev/null | "${trm_jsoncmd}" -ql1 -e '@.packages.travelmate')"
-
-if [ -z "${trm_mailreceiver}" ]; then
- "${trm_logger}" -p "err" -t "trm-${trm_ver}[${$}]" "please set the mail receiver with the 'trm_mailreceiver' option" 2>/dev/null
- exit 1
-fi
-
-if [ "${trm_debug}" = "1" ]; then
- debug="--debug"
-fi
-
-# info preparation
-#
-sys_info="$(
- strings /etc/banner 2>/dev/null
- ubus call system board | awk 'BEGIN{FS="[{}\"]"}{if($2=="kernel"||$2=="hostname"||$2=="system"||$2=="model"||$2=="description")printf " + %-12s: %s\n",$2,$4}'
-)"
-trm_info="$(/etc/init.d/travelmate status 2>/dev/null)"
-sta_info="$(jsonfilter -i "${trm_rtfile}" -q -l1 -e '@.data.station_id')"
-trm_mailtopic="$(uci_get travelmate global trm_mailtopic "travelmate connection to '${sta_info}'")"
-trm_mailhead="From: ${trm_mailsender}\nTo: ${trm_mailreceiver}\nSubject: ${trm_mailtopic}\nReply-to: ${trm_mailsender}\nMime-Version: 1.0\nContent-Type: text/html;charset=utf-8\nContent-Disposition: inline\n\n"
-
-# mail body
-#
-trm_mailtext="<html><body><pre style='font-family:monospace;padding:20;background-color:#f3eee5;white-space:pre-wrap;overflow-x:auto;' >"
-trm_mailtext="${trm_mailtext}\n<strong>++\n++ System Information ++\n++</strong>\n${sys_info}"
-trm_mailtext="${trm_mailtext}\n\n<strong>++\n++ Travelmate Information ++\n++</strong>\n${trm_info}"
-trm_mailtext="${trm_mailtext}</pre></body></html>"
-
-# send mail
-#
-printf "%b" "${trm_mailhead}${trm_mailtext}" 2>/dev/null | "${trm_mailcmd}" ${debug} -a "${trm_mailprofile}" "${trm_mailreceiver}" >/dev/null 2>&1
-"${trm_logger}" -p "info" -t "trm-${trm_ver}[${$}]" "mail sent to '${trm_mailreceiver}' with rc '${?}'" 2>/dev/null
# set (s)hellcheck exceptions
# shellcheck disable=all
-. "/lib/functions.sh"
-
export LC_ALL=C
export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
-
vpn="${1}"
vpn_action="${2}"
vpn_service="${3}"
vpn_iface="${4}"
vpn_instance="${5}"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_captiveurl="$(uci_get travelmate global trm_captiveurl "http://detectportal.firefox.com")"
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (X11; Linux x86_64; rv:144.0) Gecko/20100101 Firefox/144.0")"
-trm_ubuscmd="$(command -v ubus)"
-trm_jsoncmd="$(command -v jsonfilter)"
-trm_logger="$(command -v logger)"
-trm_fetch="$(command -v curl)"
-trm_vpnfile="/var/state/travelmate.vpn"
+trm_funlib="/usr/lib/travelmate-functions.sh"
+if [ -z "${trm_bver}" ]; then
+ . "${trm_funlib}"
+ f_conf
+fi
f_net() {
local json_rc
-
- json_rc="$(${trm_fetch} --user-agent "${trm_useragent}" --referer "http://www.example.com" --header "Cache-Control: no-cache, no-store, must-revalidate, max-age=0" --write-out "%{response_code}" --silent --retry $((trm_maxwait / 6)) --output /dev/null --max-time $((trm_maxwait / 6)) "${trm_captiveurl}")"
+ json_rc="$(${trm_fetchcmd} ${trm_fetchparm} --user-agent "${trm_useragent}" --header "Cache-Control: no-cache, no-store, must-revalidate, max-age=0" --write-out "%{response_code}" --output /dev/null "${trm_captiveurl}")"
if [ "${json_rc}" = "200" ] || [ "${json_rc}" = "204" ]; then
json_rc="net ok"
fi
if [ "${vpn_action}" = "enable_keep" ]; then
vpn_status="$("${trm_ubuscmd}" -S call network.interface."${vpn_iface}" status 2>/dev/null | "${trm_jsoncmd}" -ql1 -e '@.up')"
fi
- "${trm_logger}" -p "info" -t "trm-vpn [${$}]" "start vpn processing (vpn: ${vpn:-"-"}, action: ${vpn_action:-"-"}, interface: ${vpn_iface:-"-"}, instance: ${vpn_instance:-"-"}, status: ${vpn_status:-"-"})"
+ f_log "info" "start vpn processing (vpn: ${vpn:-"-"}, action: ${vpn_action:-"-"}, interface: ${vpn_iface:-"-"}, instance: ${vpn_instance:-"-"}, status: ${vpn_status:-"-"})"
if [ "${vpn_action}" = "enable" ] || [ "${vpn_status}" != "true" ]; then
if [ "${vpn_status}" != "true" ]; then
/sbin/ifdown "${vpn_iface}"
sleep 1
/sbin/ifup "${vpn_iface}"
if ! "${trm_ubuscmd}" -t "$((trm_maxwait / 6))" wait_for network.interface."${vpn_iface}" >/dev/null 2>&1; then
- "${trm_logger}" -p "info" -t "trm-vpn [${$}]" "travelmate vpn interface '${vpn_iface}' does not appear on ubus on ifup event"
+ f_log "info" "travelmate vpn interface '${vpn_iface}' does not appear on ubus on ifup event"
fi
cnt=0
while :; do
net_status="$(f_net)"
if [ "${net_status}" = "net ok" ]; then
: >"${trm_vpnfile}"
- "${trm_logger}" -p "info" -t "trm-vpn [${$}]" "${vpn_service} client connection enabled '${vpn_iface}/${vpn_instance:-"-"}'" 2>/dev/null
+ f_log "info" "${vpn_service} client connection enabled '${vpn_iface}/${vpn_instance:-"-"}'"
break
fi
fi
/etc/init.d/openvpn stop "${vpn_instance}"
fi
rm -f "${trm_vpnfile}"
- "${trm_logger}" -p "info" -t "trm-vpn [${$}]" "${vpn_service} client connection can't be established '${vpn_iface}/${vpn_instance:-"-", rc: ${net_status:-"-"}}'" 2>/dev/null
+ f_log "info" "${vpn_service} client connection can't be established '${vpn_iface}/${vpn_instance:-"-", rc: ${net_status:-"-"}}'"
return 1
fi
cnt="$((cnt + 1))"
/etc/init.d/openvpn stop "${vpn_instance}"
fi
rm -f "${trm_vpnfile}"
- "${trm_logger}" -p "info" -t "trm-vpn [${$}]" "${vpn_service} client connection disabled '${vpn_iface}/${vpn_instance:-"-"}'" 2>/dev/null
+ f_log "info" "${vpn_service} client connection disabled '${vpn_iface}/${vpn_instance:-"-"}'"
fi
+++ /dev/null
-#!/bin/sh
-# ntp hotplug script for travelmate
-# Copyright (c) 2020-2024 Dirk Brenken (dev@brenken.org)
-# This is free software, licensed under the GNU General Public License v3.
-
-# set (s)hellcheck exceptions
-# shellcheck disable=all
-
-trm_init="/etc/init.d/travelmate"
-trm_ntpfile="/var/state/travelmate.ntp"
-
-if [ "${ACTION}" = "stratum" ] && [ ! -s "${trm_ntpfile}" ] && "${trm_init}" enabled; then
- printf "%s" "$(date "+%Y.%m.%d-%H:%M:%S")" > "${trm_ntpfile}"
- trm_ubuscmd="$(command -v ubus)"
- trm_jsoncmd="$(command -v jsonfilter)"
- trm_logger="$(command -v logger)"
- trm_ver="$("${trm_ubuscmd}" -S call rpc-sys packagelist '{ "all": true }' 2>/dev/null | "${trm_jsoncmd}" -ql1 -e '@.packages.travelmate')"
- "${trm_logger}" -p "info" -t "trm-${trm_ver}[${$}]" "get ntp time sync"
-fi
#!/bin/sh
# captive portal auto-login script for vodafone hotspots (DE)
-# Copyright (c) 2021-2022 Dirk Brenken (dev@brenken.org)
+# Copyright (c) 2021-2025 Dirk Brenken (dev@brenken.org)
# This is free software, licensed under the GNU General Public License v3.
# set (s)hellcheck exceptions
-# shellcheck disable=1091,3040
-
-. "/lib/functions.sh"
+# shellcheck disable=all
export LC_ALL=C
export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
+trm_funlib="/usr/lib/travelmate-functions.sh"
+if [ -z "${trm_bver}" ]; then
+ . "${trm_funlib}"
+ f_conf
+fi
+
username="${1}"
password="${2}"
trm_domain="hotspot.vodafone.de"
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_captiveurl="$(uci_get travelmate global trm_captiveurl "http://detectportal.firefox.com")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl)"
+if ! "${trm_lookupcmd}" "${trm_domain}" >/dev/null 2>&1; then
+ exit 1
+fi
# get sid
#
-redirect_url="$(${trm_fetch} --user-agent "${trm_useragent}" --referer "http://www.example.com" --connect-timeout $((trm_maxwait / 6)) --write-out "%{redirect_url}" --silent --show-error --output /dev/null "${trm_captiveurl}")"
-sid="$(printf "%s" "${redirect_url}" 2>/dev/null | awk 'BEGIN{FS="[=&]"}{printf "%s",$2}')"
+redirect_url="$("${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" --write-out "%{redirect_url}" --output /dev/null "${trm_captiveurl}")"
+sid="$(printf "%s" "${redirect_url}" 2>/dev/null | "${trm_awkcmd}" 'BEGIN{FS="[=&]"}{printf "%s",$2}')"
[ -z "${sid}" ] && exit 1
# get session
#
-raw_html="$("${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://${trm_domain}/portal/?sid=${sid}" --silent --connect-timeout $((trm_maxwait / 6)) "https://${trm_domain}/api/v4/session?sid=${sid}")"
-session="$(printf "%s" "${raw_html}" 2>/dev/null | jsonfilter -q -l1 -e '@.session')"
+raw_html="$("${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" --referer "http://${trm_domain}/portal/?sid=${sid}" "https://${trm_domain}/api/v4/session?sid=${sid}")"
+session="$(printf "%s" "${raw_html}" 2>/dev/null | "${trm_jsoncmd}" -q -l1 -e '@.session')"
[ -z "${session}" ] && exit 2
-ids="$(printf "%s" "${raw_html}" 2>/dev/null | jsonfilter -q -e '@.loginProfiles[*].id' | sort -n | awk '{ORS=" ";print $0}')"
+ids="$(printf "%s" "${raw_html}" 2>/dev/null | "${trm_jsoncmd}" -q -e '@.loginProfiles[*].id' | "${trm_sortcmd}" -n | "${trm_awkcmd}" '{ORS=" ";print $0}')"
for id in ${ids}; do
if [ "${id}" = "4" ]; then
login_id="4"
# final login request
#
if [ "${login_id}" = "4" ] && [ -n "${username}" ] && [ -n "${password}" ]; then
- raw_html="$("${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://${trm_domain}/portal/?sid=${sid}" --silent --connect-timeout $((trm_maxwait / 6)) --data "loginProfile=${login_id}&accessType=${access_type}&accountType=${account_type}&password=${password}&session=${session}&username=${username}" "https://${trm_domain}/api/v4/login?sid=${sid}")"
+ raw_html="$("${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" --referer "http://${trm_domain}/portal/?sid=${sid}" --data "loginProfile=${login_id}&accessType=${access_type}&accountType=${account_type}&password=${password}&session=${session}&username=${username}" "https://${trm_domain}/api/v4/login?sid=${sid}")"
fi
-success="$(printf "%s" "${raw_html}" 2>/dev/null | jsonfilter -q -l1 -e '@.success')"
+success="$(printf "%s" "${raw_html}" 2>/dev/null | "${trm_jsoncmd}" -q -l1 -e '@.success')"
[ "${success}" = "true" ] && exit 0 || exit 255
#!/bin/sh
# captive portal auto-login script for bahn/ICE hotspots (DE)
-# Copyright (c) 2020-2024 Dirk Brenken (dev@brenken.org)
+# Copyright (c) 2020-2025 Dirk Brenken (dev@brenken.org)
# This is free software, licensed under the GNU General Public License v3.
# set (s)hellcheck exceptions
# shellcheck disable=all
-. "/lib/functions.sh"
-
export LC_ALL=C
export PATH="/usr/sbin:/usr/bin:/sbin:/bin"
+trm_funlib="/usr/lib/travelmate-functions.sh"
+if [ -z "${trm_bver}" ]; then
+ . "${trm_funlib}"
+ f_conf
+fi
+
trm_domain="wifi.bahn.de"
-if ! nslookup "${trm_domain}" >/dev/null 2>&1; then
+if ! "${trm_lookupcmd}" "${trm_domain}" >/dev/null 2>&1; then
trm_domain="login.wifionice.de"
- if ! nslookup "${trm_domain}" >/dev/null 2>&1; then
+ if ! "${trm_lookupcmd}" "${trm_domain}" >/dev/null 2>&1; then
exit 1
fi
fi
-trm_useragent="$(uci_get travelmate global trm_useragent "Mozilla/5.0 (Linux x86_64; rv:90.0) Gecko/20100101 Firefox/90.0")"
-trm_maxwait="$(uci_get travelmate global trm_maxwait "30")"
-trm_fetch="$(command -v curl)"
-
# get security token
#
-"${trm_fetch}" --user-agent "${trm_useragent}" --referer "http://www.example.com" --connect-timeout $((trm_maxwait / 6)) --cookie-jar "/tmp/${trm_domain}.cookie" --silent --show-error --output /dev/null "https://${trm_domain}/en/"
-sec_token="$(awk '/csrf/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
+"${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" --cookie-jar "/tmp/${trm_domain}.cookie" --output /dev/null "https://${trm_domain}/en/"
+sec_token="$("${trm_awkcmd}" '/csrf/{print $7}' "/tmp/${trm_domain}.cookie" 2>/dev/null)"
rm -f "/tmp/${trm_domain}.cookie"
[ -z "${sec_token}" ] && exit 2
# final post request
#
-raw_html="$("${trm_fetch}" --user-agent "${trm_useragent}" --connect-timeout $((trm_maxwait / 6)) --header "Cookie: csrf=${sec_token}" --data "login=true&CSRFToken=${sec_token}" --silent --show-error "https://${trm_domain}/en/")"
+raw_html="$("${trm_fetch}" ${trm_fetchparm} --user-agent "${trm_useragent}" --header "Cookie: csrf=${sec_token}" --data "login=true&CSRFToken=${sec_token}" "https://${trm_domain}/en/")"
[ -z "${raw_html}" ] && exit 0 || exit 255